<template>
  <v-list-item
    :key="item.title"
    :to="item?.to"
    class="!p-0 !min-h-min !m-0"
  >
    <!-- nested -->
    <v-list-group v-if="item.children.length" :value="`group-${item.title}`">
      <template v-slot:activator="{ props }">
        <v-list-item v-bind="props">
          <v-list-item-title
            class="flex gap-2.5 active:!bg-white text-secondary hover:text-gray transition-colors duration-300 transform"
            :class="isActivePage(item.to) ? 'text-gray' : ''"
          >

            <p v-if="item?.title" class="pt-0.5 text-base text-secondary font-medium whitespace-normal">
              <v-icon v-if="item?.icon" class="!text-lg mt-0 text-secondary">
                {{ item.icon }}
              </v-icon>&nbsp;<span>{{ $t(item.title) }}</span>
            </p>
          </v-list-item-title>
        </v-list-item>
      </template>

      <!-- children of nested -->
      <v-list-item
        v-for="(child, i) in item.children"
        :key="`${item.title}-child-${i}`"
        :to="child?.to"
      >
        <v-list-item-title
          class="flex gap-2.5 active:!bg-white text-secondary hover:text-gray transition-colors duration-300 transform"
          :class="isActivePage(child.to) ? 'text-gray' : ''"
        >

          <p v-if="child?.title" class="pt-0.5 text-base text-secondary font-medium whitespace-normal">
            <v-icon v-if="child?.icon" class="!text-lg mt-0 text-secondary">
              {{ child.icon }}
            </v-icon>&nbsp;<span>{{ $t(child.title) }}</span>
          </p>
        </v-list-item-title>
      </v-list-item>
    </v-list-group>

    <!-- regular -->
    <v-list-item v-else v-show="!toggleMini" class="!p-0" :to="item?.to">
      <v-list-item-title
        class="flex gap-2.5 active:!bg-white text-secondary hover:text-gray transition-colors duration-300 transform"
        :class="isActivePage(item.to) ? 'text-gray' : ''"
      >

        <p v-if="item?.title" class="pt-0.5 text-base text-secondary font-medium whitespace-normal">
          <v-icon v-if="item?.icon" class="!text-lg mt-0 text-secondary">
            {{ item.icon }}
          </v-icon>&nbsp;<span>{{ $t(item.title) }}</span>
        </p>
      </v-list-item-title>
    </v-list-item>
  </v-list-item>
</template>
<script lang="ts" setup>
import { ref } from 'vue';
import { menuItems } from './menu-items';
import { GeneralGuard } from '@/guards/GeneralGuard';
import { useRoute } from 'vue-router';
import { computed } from 'vue';


import { useI18n } from 'vue-i18n';

const { t: translate } = useI18n();

const items = ref(menuItems());
const route = useRoute();

const props = defineProps({
  item: {
    type: Object,
    default() {
      return {
        title: '',
        to: {
          name: ''
        },
        external: false,
        isAllowed: true,
        children: {}
      };
    },
  },
});

const sidebarMenu = ref(true);
const sidebarCollapsed = ref(false);
const toggleMini = ref(false);

// const toggleSidebar = () => {
//     toggleMini.value = !toggleMini.value;
// };

const filteredItems = computed(() => {
  return items.value.filter((item) => item && isPageAllowed(item.to));
});

const isActivePage = (page: any) => {
  return route.name === page.name;
};
const isPageAllowed = (targetPage: any) => {
  const guard = new GeneralGuard();
  return guard.canEnterMenuItem(targetPage);
};
</script>